- Main Page
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Classes | Public Slots | Signals | Public Member Functions | List of all members
AuthPluginInterface Class Referenceabstract
Inheritance diagram for AuthPluginInterface:
[legend]

## Classes
class | Interface
| authentication plugins More...

## Public Slots
virtual void | userActionFinished (const SignOn::UiSessionData &data)
| User interaction completed. More...
virtual void | refresh (const SignOn::UiSessionData &data)
| Refreshes given session. More...

## Signals
void | result (const SignOn::SessionData &data)
| Emitted when authentication process has been completed for given data and there are no errors. More...
void | store (const SignOn::SessionData &data)
| Emitted when authentication process want to store session data parameters for later use. More...
void | error (const SignOn::Error &err)
| Emitted when authentication process has been completed for given data and resulting an error. More...
void | userActionRequired (const SignOn::UiSessionData &data)
| Emitted when authentication process need to interact with user. More...
void | refreshed (const SignOn::UiSessionData &data)
| Emitted when authentication process has completed refresh request. More...
void | statusChanged (const AuthPluginState state, const QString &message=QString())
| Emitted to report status of authentication process to signond for informing client application. More...

## Public Member Functions
| AuthPluginInterface (QObject *parent=0)
virtual | ~AuthPluginInterface ()
| Destructor.
virtual QString | type () const =0
| Gets the type of the plugin. More...
virtual QStringList | mechanisms () const =0
| Gets the list of supported mechanisms. More...
virtual void | cancel ()
| Requests to cancel the process. More...
virtual void | abort ()
| Requests to abort the process. More...
virtual void | process (const SignOn::SessionData &inData, const QString &mechanism=QString())=0
| Process authentication. More...

## Detailed Description

Definition at line 82 of file authpluginif.h.

## Member Function Documentation

virtual void AuthPluginInterface::abort | ( |  | ) |
| inline virtual

Requests to abort the process.

Process is terminated after this call. Reimplement this in order to execute specific instructions before process is killed.

Definition at line 123 of file authpluginif.h.

virtual void AuthPluginInterface::cancel | ( |  | ) |
| inline virtual

Requests to cancel the process.

Process is terminated after this call. Reimplement this in order to execute specific instructions before the effective cancel occurres.

Definition at line 115 of file authpluginif.h.

void AuthPluginInterface::error | ( | const SignOn::Error & | err | ) |
| signal

Emitted when authentication process has been completed for given data and resulting an error.

Parameters

  err | The error object
  errorMessage | Resulting error message

virtual QStringList AuthPluginInterface::mechanisms | ( |  | ) | const
| pure virtual

Gets the list of supported mechanisms.

Returns
  List of mechanisms

virtual void AuthPluginInterface::process | ( | const SignOn::SessionData & | inData,
|  | const QString & | mechanism = `QString()`
| ) |  |
| pure virtual

Process authentication.

Authentication can be logging to a server, obtain token(s) from a server, calculate response using given challenge, etc. Given session data is used to do authentication and return response. Signal result() is emitted when authentication is completed, or signal error() if authentication failed.

See Also
  result
  error

Parameters

  inData | Input data for authentication
  mechanism | Mechanism to use to do authentication

virtual void AuthPluginInterface::refresh | ( | const SignOn::UiSessionData & | data | ) |
| inline virtual slot

Refreshes given session.

Signond uses this slot to refresh data in given ui session. Mostly used to refresh a captcha images during the user interaction. Signal refreshed() or error() must be emitted when refresh is completed. This must be reimplemented to refresh the captcha image.

See Also
  UiSessionData
  refreshed

Note
  emitting signal userActionRequired() is not allowed to use before ui session is finished.

Parameters

  data | Ui session data to be refreshed

Definition at line 231 of file authpluginif.h.

References refreshed().

void AuthPluginInterface::refreshed | ( | const SignOn::UiSessionData & | data | ) |
| signal

Emitted when authentication process has completed refresh request.

Plugin must emit signal refreshed() to response to refresh() call.

See Also
  refreshed

Parameters

  data | Refreshed ui session data

Referenced by refresh().

void AuthPluginInterface::result | ( | const SignOn::SessionData & | data | ) |
| signal

Emitted when authentication process has been completed for given data and there are no errors.

Parameters

  data | Resulting SessionData, need to be returned to client

void AuthPluginInterface::statusChanged | ( | const AuthPluginState | state,
|  | const QString & | message = `QString()`
| ) |  |
| signal

Emitted to report status of authentication process to signond for informing client application.

Parameters

  state | Plugin process state

See Also
  AuthPluginState

Parameters

  message | Optional message for client application

void AuthPluginInterface::store | ( | const SignOn::SessionData & | data | ) |
| signal

Emitted when authentication process want to store session data parameters for later use.

Stored parameters are added into SessionData in following process calls. This is useful when authentication is using permanent tokens.

Note
  This is shared within same identity using same method only.
  There can be storage size limitation for data that can be stored.

Parameters

  data | Resulting SessionData, need to be returned to client

virtual QString AuthPluginInterface::type | ( |  | ) | const
| pure virtual

Gets the type of the plugin.

Returns
  Plugin type

virtual void AuthPluginInterface::userActionFinished | ( | const SignOn::UiSessionData & | data | ) |
| inline virtual slot

User interaction completed.

Signond uses this slot to notice the end of ui session. This is a response to userActionRequired() signal. This must be reimplemented to get the response from the user interaction.

See Also
  UiSessionData
  userActionRequired

Parameters

  data | User completed ui session data

Definition at line 215 of file authpluginif.h.

void AuthPluginInterface::userActionRequired | ( | const SignOn::UiSessionData & | data | ) |
| signal

Emitted when authentication process need to interact with user.

Basic use cases are: query password, verify captcha, show url. Can also be used to get username/password for proxy authentication etc. Slot userActionFinished() is called when interaction is completed.

See Also
  userActionFinished
  SignOn::UiSessionData

Note
  slot userActionFinished() should be reimplemented to get result.

Parameters

  data | Ui session data to be filled within user interaction

The documentation for this class was generated from the following file:

- SignOn/authpluginif.h